
    #include <p16f877a.inc>

    __CONFIG _RC_OSC & _WDT_OFF & _PWRTE_OFF & _BODEN_OFF & _LVP_OFF & _CPD_OFF & _WRT_OFF & _DEBUG_OFF & _CP_OFF


; -----------------------------------------------------------------------
; Variables declaration
INT_VAR UDATA_SHR
w_saved      RES 1 ; variable used for context saving
status_saved RES 1 ; variable used for context saving
pclath_saved RES 1 ; variable used for context saving

var1         RES 1 ; example variable

; -----------------------------------------------------------------------
; reset vector
STARTUP CODE 0x000
    nop                    ; needed for ICD2 debugging
    movlw   high start     ; load upper byte of 'start' label
    movwf   PCLATH         ; initialize PCLATH
    goto    start          ; go to start of main code

; interrupt vector
INT_VECTOR CODE 0x004
    goto    interrupt      ; go to start of interrupt code

; relocatable code
PROG CODE
interrupt
    movwf   w_saved        ; save context
    swapf   STATUS,w
    movwf   status_saved
    movf    PCLATH,w       ; only required if using more than first page
    movwf   pclath_saved
    clrf    PCLATH
    ; << insert interrupt code >>
    movf    pclath_saved,w ; restore context
    movwf   PCLATH
    swapf   status_saved,w
    movwf   STATUS
    swapf   w_saved,f
    swapf   w_saved,w
    retfie

start
    BANKSEL TRISB
    MOVLW 0x03
    MOVWF TRISB
    CLRF TRISD
    BANKSEL PORTB	
loop:
    MOVLW 0xF0
    MOVWF PORTB
    MOVLW 0xFF
    MOVWF PORTD	
    goto    loop              ; loop forever

END
