#include"picsimlab11.h"
#include"picsimlab11_d.cc"

CPWindow1 Window1;


//Implementation

#include"picsimlab12.h"
#include "../picsim.h"
#include "id.h"
#include <time.h>



extern char PROGDEVICE[100];

int prog_init(void);
int prog_loop(pic16f * pic);
int prog_end(void);

typedef struct
{
unsigned int x1;
unsigned int x2;
unsigned int y1;
unsigned int y2;
char name[10];
unsigned short id;
}input_t;

typedef struct
{
unsigned int x1;
unsigned int x2;
unsigned int y1;
unsigned int y2;
unsigned int r;
char name[10];
unsigned short id;
}output_t;

long int NSTEP=25000;

input_t  input[30];
output_t output[30];

int inputc=0;
int outputc=0;

int picrun=1;

int picpwr=1;

int picrst=0;

int dsp_led=0;

pic16f pic;

unsigned int lm[18]; //luminosidade media
unsigned int lm1[18]; //luminosidade media
unsigned int lm2[18]; //luminosidade media
  
int p_RA1=1; 
int p_RA2=1; 
int p_RA3=1; 
int p_RA4=1; 




int over=0;

void
CPWindow1::timer1_EvOnTime(CControl * control)
{
  int i,pi;

  clock_t cstart, cend;
  double cpu_time_used;
  const picpin * pins;

   cstart = clock();

  draw1.Canvas.Init();
        
    
  for(i=0;i<outputc;i++)
  {
    if(output[i].r == 0)
    {
      draw1.Canvas.SetFgColor (30, 0, 0);
      
      if(dsp_led == 1)
      {
          switch(output[i].id)
          {         
            case O_A1: draw1.Canvas.SetBgColor (lm1[7], 0, 0);break;
            case O_B1: draw1.Canvas.SetBgColor (lm1[8], 0, 0);break;
            case O_C1: draw1.Canvas.SetBgColor (lm1[10], 0, 0);break;
            case O_D1: draw1.Canvas.SetBgColor (lm1[11], 0, 0);break;
            case O_E1: draw1.Canvas.SetBgColor (lm1[12], 0, 0);break;
            case O_F1: draw1.Canvas.SetBgColor (lm1[6], 0, 0);break;
            case O_G1: draw1.Canvas.SetBgColor (lm1[5], 0, 0);break;
            case O_P1: draw1.Canvas.SetBgColor (lm1[9], 0, 0);break;
            case O_A2: draw1.Canvas.SetBgColor (lm2[7], 0, 0);break;
            case O_B2: draw1.Canvas.SetBgColor (lm2[8], 0, 0);break;
            case O_C2: draw1.Canvas.SetBgColor (lm2[10], 0, 0);break;
            case O_D2: draw1.Canvas.SetBgColor (lm2[11], 0, 0);break;
            case O_E2: draw1.Canvas.SetBgColor (lm2[12], 0, 0);break;
            case O_F2: draw1.Canvas.SetBgColor (lm2[6], 0, 0);break;
            case O_G2: draw1.Canvas.SetBgColor (lm2[5], 0, 0);break;
            case O_P2: draw1.Canvas.SetBgColor (lm2[9], 0, 0);break;
          }
      }
      else
      {
        draw1.Canvas.SetBgColor (30, 0, 0);
      } 
      
     if(output[i].id == O_JP1) draw1.Canvas.SetBgColor (150, 150, 150);

      draw1.Canvas.Rectangle (1, output[i].x1, output[i].y1, output[i].x2-output[i].x1,output[i].y2-output[i].y1 );
      
      if(output[i].id == O_JP1)
      {
       if(dsp_led == 0)
       {
         draw1.Canvas.SetBgColor (70, 70, 70);
         draw1.Canvas.Rectangle (1, output[i].x1, output[i].y1, (int)((output[i].x2-output[i].x1)*0.65),output[i].y2-output[i].y1 );
         draw1.Canvas.SetBgColor (220, 220, 0);
         draw1.Canvas.Circle (1,output[i].x1+(int)((output[i].x2-output[i].x1)*0.80), output[i].y1+((output[i].y2-output[i].y1)/2),3);
       }
       else
       {
         draw1.Canvas.SetBgColor (70, 70, 70);
         draw1.Canvas.Rectangle (1, output[i].x1+((int)((output[i].x2-output[i].x1)*0.35)), output[i].y1, (int)((output[i].x2-output[i].x1)*0.65),output[i].y2-output[i].y1 );
         draw1.Canvas.SetBgColor (220, 220, 0);
         draw1.Canvas.Circle (1,output[i].x1+(int)((output[i].x2-output[i].x1)*0.20), output[i].y1+((output[i].y2-output[i].y1)/2),3);
       };
      }       
    }
    else
    {
      draw1.Canvas.SetFgColor (0, 0, 0);
      
 
      if(dsp_led == 0)
      {
        switch(output[i].id)
        {
          case O_RB0: draw1.Canvas.SetBgColor (lm[5], 0, 0);break;
          case O_RB1: draw1.Canvas.SetBgColor (lm[6], 0, 0);break;
          case O_RB2: draw1.Canvas.SetBgColor (lm[7], 0, 0);break;
          case O_RB3: draw1.Canvas.SetBgColor (lm[8], 0, 0);break;
          case O_RB4: draw1.Canvas.SetBgColor (lm[9], 0, 0);break;
          case O_RB5: draw1.Canvas.SetBgColor (lm[10], 0, 0);break;
          case O_RB6: draw1.Canvas.SetBgColor (lm[11], 0, 0);break;
          case O_RB7: draw1.Canvas.SetBgColor (lm[12], 0, 0);break;
        }
      }
      else
      {
         if(strstr(output[i].name,"RB") != NULL)
            draw1.Canvas.SetBgColor (30, 0, 0);
      }
      
      switch(output[i].id)
      {
        case O_RA0: draw1.Canvas.SetBgColor (0, lm[16], 0);break;
        case O_RA1: draw1.Canvas.SetBgColor (0, lm[17], 0);break;
        case O_RA2: draw1.Canvas.SetBgColor (0, lm[0], 0);break;
        case O_RA3: draw1.Canvas.SetBgColor (0, lm[1], 0);break;
        case O_RA0L: draw1.Canvas.SetBgColor (lm[16],lm[16], 0);break;
      } 

      draw1.Canvas.Circle (1,output[i].x1, output[i].y1,output[i].r );
    };    

  };
  draw1.Canvas.End();
  draw1.Update ();
  

   for(pi=0;pi<18;pi++)
   {
     lm[pi]=0;
     lm1[pi]=0;
     lm2[pi]=0;
   };


  pins = pic.pins;
        

   if(picpwr == 1)
   for(i=0;i<NSTEP;i++)
      {
  
       pic_set_pin(&pic,18,p_RA1); 
       pic_set_pin(&pic,1,p_RA2); 
       pic_set_pin(&pic,2,p_RA3); 
       pic_set_pin(&pic,3,p_RA4); 
        
        pic_step(&pic,0);

        for(pi=0;pi<18;pi++) if(pins[pi].value == 1) lm[pi]++;
      
        //pull-up extern 
        if((pins[17].dir == 1)&&(p_RA1 == 1))lm[17]++; 
        if((pins[0].dir  == 1)&&(p_RA2 == 1))lm[0]++; 
        if((pins[1].dir  == 1)&&(p_RA3 == 1))lm[1]++; 

        if(dsp_led ==1)
          for(pi=5;pi<13;pi++)
          {
             if((pins[pi].value == 1)&&(pins[9].value == 0)) lm1[pi]++;
             if((pins[pi].value == 1)&&(pins[9].value == 1)) lm2[pi]++;
          }
       }
 

   for(pi=0;pi<18;pi++)
   { 
    lm[pi]= (int)(((225.0*lm[pi])/NSTEP)+30);
    lm1[pi]= (int)(((225.0*lm1[pi])/NSTEP)+30);
    lm2[pi]= (int)(((225.0*lm2[pi])/NSTEP)+30);
   }
   lm1[9]=30; 
   lm2[9]=30; 
     

   cend = clock();
   cpu_time_used = ((double) (cend - cstart)) / CLOCKS_PER_SEC;
 


   if(cpu_time_used > 0.09)
   {
      over++;
      if(over > 5)
      { 
          picpwr=0; 
          picrun=0;
          pic_reset(&pic,1);
          pic_set_pin(&pic,6,0);
          pic_set_pin(&pic,7,0);
          pic_set_pin(&pic,8,0);
          pic_set_pin(&pic,9,0);
          pic_set_pin(&pic,10,0);
          pic_set_pin(&pic,11,0);
          pic_set_pin(&pic,12,0);
          pic_set_pin(&pic,13,0);
        
          p_RA1=0; 
          p_RA2=0; 
          p_RA3=0; 
          p_RA4=0;
         
         over=0;  

	 Message(wxT("Clock Overload.\n Decrease Clock and press PWR!")); 
         statusbar1.SetField(0,wxT("Stoped"));
       }  
   }
   else
   {
      over=0;
   }


   if(picpwr==1) 
      prog_loop(&pic);

};


void
CPWindow1::draw1_EvMouseButtonPress(CControl * control, uint button, uint x, uint y,uint state)
{
  int i,pa;
  
  for(i=0;i<inputc;i++)
  {
    if(((input[i].x1 <= x)&&(input[i].x2 >= x))&&((input[i].y1 <= y)&&(input[i].y2 >= y)))
    {
    
      switch(input[i].id) 
      { 
      case I_ICSP:
      {
        pa=picpwr; 
        picpwr=0;
        if(filedialog1.Run())
        {
          pic_end(&pic);
          picrun=pic_init(&pic,P16F628A,filedialog1.GetFileName().char_str(),1,NSTEP*40.0);
 
          if(picrun) 
            Window1.SetTitle(wxT("PicsimLab1 - ")+basename(filedialog1.GetFileName()));          
          else
            Window1.SetTitle(wxT("PicsimLab1"));
          
          p_RA1=1; 
          p_RA2=1; 
          p_RA3=1; 
          p_RA4=1; 
          pic_set_pin(&pic,18,p_RA1); 
          pic_set_pin(&pic,1,p_RA2); 
          pic_set_pin(&pic,2,p_RA3); 
          pic_set_pin(&pic,3,p_RA4); 
        }
        picpwr=pa;
      };break;  
       
      case I_JP1:
      {
        dsp_led^=0x01; 
      };break;
      
      case I_PWR:
      {
        if(picpwr == 1) 
        { 
          picrun=0; 
          picpwr=0; 
          pic_reset(&pic,1);
          pic_set_pin(&pic,6,0);
          pic_set_pin(&pic,7,0);
          pic_set_pin(&pic,8,0);
          pic_set_pin(&pic,9,0);
          pic_set_pin(&pic,10,0);
          pic_set_pin(&pic,11,0);
          pic_set_pin(&pic,12,0);
          pic_set_pin(&pic,13,0);
          
	  p_RA1=0; 
          p_RA2=0; 
          p_RA3=0; 
          p_RA4=0; 
          statusbar1.SetField(0,wxT("Stoped"));
        }
        else
        {
          picpwr=1; 
          picrun=1;
          pic_reset(&pic,1);
          pic_set_pin(&pic,6,0);
          pic_set_pin(&pic,7,0);
          pic_set_pin(&pic,8,0);
          pic_set_pin(&pic,9,0);
          pic_set_pin(&pic,10,0);
          pic_set_pin(&pic,11,0);
          pic_set_pin(&pic,12,0);
          pic_set_pin(&pic,13,0);
        
          p_RA1=1; 
          p_RA2=1; 
          p_RA3=1; 
          p_RA4=1; 
          pic_set_pin(&pic,18,p_RA1); 
          pic_set_pin(&pic,1,p_RA2); 
          pic_set_pin(&pic,2,p_RA3); 
          pic_set_pin(&pic,3,p_RA4); 
          statusbar1.SetField(0,wxT("Running..."));
        } 
      };break;
      
      case I_RST:
      {
          if(picpwr == 1)
          {
            picrst=1; 
            picpwr=0;
          } 
      };break;
       
      case I_RA1:
      {
        p_RA1=0;
      };break;

      case I_RA2:
      {
        p_RA2=0; 
      };break;
 
      case I_RA3:
      {
        p_RA3=0; 
      };break;

      case I_RA4:
      {
        p_RA4=0; 
      };break;

     }
   
    }
  }

}



void
CPWindow1::draw1_EvMouseButtonRelease(CControl * control, uint button, uint x, uint y,uint state)
{
  int i;
  

  for(i=0;i<inputc;i++)
  {
    if(((input[i].x1 <= x)&&(input[i].x2 >= x))&&((input[i].y1 <= y)&&(input[i].y2 >= y)))
    {
  
      switch(input[i].id)
      {
      case I_RST:
      {
          if(picrst == 1)
          {
            picpwr=1;
            picrst=0;
            if(pic_reset(&pic,-1))
            { 
              p_RA1=1; 
              p_RA2=1; 
              p_RA3=1; 
              p_RA4=1; 
              pic_set_pin(&pic,18,p_RA1); 
              pic_set_pin(&pic,1,p_RA2); 
              pic_set_pin(&pic,2,p_RA3); 
              pic_set_pin(&pic,3,p_RA4); 
            }
          } 
      };break;
      case I_RA1:
      {
        p_RA1=1; 
      };break;
      case I_RA2:
      {
        p_RA2=1; 
      };break;
      case I_RA3:
      {
        p_RA3=1; 
      };break;
      case I_RA4:
      {
        p_RA4=1; 
      };break;

      } 
    } 
  }
};


void
CPWindow1::draw1_EvKeyboardPress(CControl * control, uint key, uint x, uint y,uint mask)
{

  if(key == '1')
  {
    p_RA1=0; 
  }
  if(key == '2')
  {
    p_RA2=0; 
  }
  if(key == '3')
  {
    p_RA3=0; 
  }
  if(key == '4')
  {
    p_RA4=0; 
  }

};


void
CPWindow1::draw1_EvKeyboardRelease(CControl * control, uint key, uint x, uint y,uint mask)
{
  
  if(key == '1')
  {
    p_RA1=1; 
  }
  
  if(key == '2')
  {
    p_RA2=1; 
  }
  
  if(key == '3')
  {
    p_RA3=1; 
  }
  
  if(key == '4')
  {
    p_RA4=1; 
  }

};




void
CPWindow1::_EvOnCreate(CControl * control)
{
  FILE *fin;
  char line[256];
  char fname[1024];
  char *it;
  char *shape;
  char *coords;
  char *name;
  char *val;
  
  int x1,y1,x2,y2,r;
 
  sprintf(fname,"%sinput.map",_SHARE_);
  fin=fopen(fname,"r");

  if(fin)
  {
    while(fgets(line,256,fin))
    {
      it=strtok(line,"< =\"");
      if(strcmp("area",it) == 0)
      {
        strtok(NULL,"< =\"");
        shape=strtok(NULL,"< =\"");
        strtok(NULL,"< =\"");
        coords=strtok(NULL,"< =\"");
        strtok(NULL,"< =\"");
        name=strtok(NULL,"< =\"");
        
       
          sscanf(coords,"%i,%i,%i,%i\n",&x1,&y1,&x2,&y2);

          input[inputc].x1=x1; 
          input[inputc].y1=y1; 
          input[inputc].x2=x2; 
          input[inputc].y2=y2;
          strcpy(input[inputc].name,name); 
          input[inputc].id=get_in_id(input[inputc].name);
          inputc++;
      }
    } 
    fclose(fin);
  }
  else
  {
    Message(wxT("Error open input.map"));
    printf("Error open input.map!\n");
  }
 
 
  sprintf(fname,"%soutput.map",_SHARE_);
  fin=fopen(fname,"r");

  if(fin)
  {
    while(fgets(line,256,fin))
    {
      it=strtok(line,"< =\"");
      if(strcmp("area",it) == 0)
      {
        strtok(NULL,"< =\"");
        shape=strtok(NULL,"< =\"");
        strtok(NULL,"< =\"");
        coords=strtok(NULL,"< =\"");
        strtok(NULL,"< =\"");
        name=strtok(NULL,"< =\"");
        
        
	if(strcmp("rect",shape)== 0)
        {
          sscanf(coords,"%i,%i,%i,%i\n",&x1,&y1,&x2,&y2);
          
          output[outputc].x1=x1; 
          output[outputc].y1=y1; 
          output[outputc].x2=x2; 
          output[outputc].y2=y2;
          output[outputc].r=0;
          strcpy(output[outputc].name,name); 
          output[outputc].id=get_out_id(output[outputc].name);
          outputc++;
        }
        else 
        {
          sscanf(coords,"%i,%i,%i\n",&x1,&y1,&r);
          
          output[outputc].x1=x1; 
          output[outputc].y1=y1; 
          output[outputc].r=r; 
          strcpy(output[outputc].name,name); 
          output[outputc].id=get_out_id(output[outputc].name);
          outputc++;
        }
      }
    } 
  
    fclose(fin);
  }
  else
  {
    Message(wxT("Error open output.map"));
    printf("Error open output.map!\n");
  }
  

  sprintf(fname,"%spicsimlab1.ini",_SHARE_);
  fin=fopen(fname,"r");
    

  if(fin)
  {
    while(fgets(line,256,fin))
    {
      name=strtok(line,"< =\"\n");
      val=strtok(NULL,"< =\"\n");
#ifndef _WIN_
      if(strcmp("lserial",name) == 0)strcpy(SERIALDEVICE,val);
      if(strcmp("lprog",name) == 0)strcpy(PROGDEVICE,val);
#else
      if(strcmp("wserial",name) == 0)strcpy(SERIALDEVICE,val);
      if(strcmp("wprog",name) == 0)strcpy(PROGDEVICE,val);
#endif
      if(strcmp("clock",name) == 0)
      {
        combo1.SetText(String::FromAscii(val)); 
        NSTEP= (int)(atof(combo1.GetText())*25000); 
        pic.freq=NSTEP*40.0;
      }
    }
    fclose(fin);
  }
  else
  {
    printf("Error open picsimlab1.ini!\n");
    Message(wxT("Error open picsimlab1.ini!"));
    SERIALDEVICE[0]=0;
    PROGDEVICE[0]=0;
  }

  pic_init(&pic,P16F628A,NULL,0,NSTEP*40.0);
  pic_set_pin(&pic,6,0);
  pic_set_pin(&pic,7,0);
  pic_set_pin(&pic,8,0);
  pic_set_pin(&pic,9,0);
  pic_set_pin(&pic,10,0);
  pic_set_pin(&pic,11,0);
  pic_set_pin(&pic,12,0);
  pic_set_pin(&pic,13,0);
        
  p_RA1=1; 
  p_RA2=1; 
  p_RA3=1; 
  p_RA4=1; 
  pic_set_pin(&pic,18,p_RA1); 
  pic_set_pin(&pic,1,p_RA2); 
  pic_set_pin(&pic,2,p_RA3); 
  pic_set_pin(&pic,3,p_RA4); 
 
  prog_init();

  
  statusbar1.SetField(1,wxT("Programmer Port: ")+String::FromAscii(PROGDEVICE));
  statusbar1.SetField(0,wxT("Running..."));
 

  Window2.html1.SetLoadFile(String::FromAscii(_SHARE_)+wxT("HELP.html"));
 
  draw1.SetImgFileName(String::FromAscii(_SHARE_)+wxT("picsimlab1.png"));
  
  timer1.SetRunState(1);
};

void
CPWindow1::combo1_EvOnComboChange(CControl * control)
{

  NSTEP= (int)(atof(combo1.GetText())*25000); 

  pic.freq=NSTEP*40.0;
};


void
CPWindow1::_EvOnDestroy(CControl * control)
{
   pic_end(&pic);
   prog_end();
};


void
CPWindow1::menu1_File_LoadHex_EvMenuActive(CControl * control)
{
  int pa;

        pa=picpwr; 
        picpwr=0;
        if(filedialog1.Run())
        {
          pic_end(&pic);
          picrun=pic_init(&pic,P16F628A,filedialog1.GetFileName().char_str(),1,NSTEP*40.0);
 
          if(picrun) 
            Window1.SetTitle(wxT("PicsimLab1 - ")+basename(filedialog1.GetFileName()));          
          else
            Window1.SetTitle(wxT("PicsimLab1"));
          
          p_RA1=1; 
          p_RA2=1; 
          p_RA3=1; 
          p_RA4=1; 
          pic_set_pin(&pic,18,p_RA1); 
          pic_set_pin(&pic,1,p_RA2); 
          pic_set_pin(&pic,2,p_RA3); 
          pic_set_pin(&pic,3,p_RA4); 
        }
        picpwr=pa;
};

void
CPWindow1::menu1_File_Exit_EvMenuActive(CControl * control)
{
  WDestroy();
};

void
CPWindow1::menu1_Help_Contents_EvMenuActive(CControl * control)
{
  Window2.Show();
};

void
CPWindow1::menu1_Help_About_EvMenuActive(CControl * control)
{
  Message(wxT("Developed by L.C. Gamboa <lcgamboa@yahoo.com>"));
};












