/* ########################################################################

   PICsim - PIC simulator

   ########################################################################

   Copyright (c) : 2008  Luis Claudio Gamba Lopes

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   For e-mail suggestions :  lcgamboa@yahoo.com
   ######################################################################## */

#ifdef __cplusplus
extern "C" {
#endif

#define INDF	0x00
#define TMR0	0x01
#define PCL	0x02
#define STATUS 	0x03
#define FSR	0x04
#define PORTA	0x05
#define PORTB	0x06
#define PORTC	0x07
#define PORTD	0x08
#define PORTE	0x09
#define PCLATH	0x0A
#define INTCON  0x0B
#define PIR1	0x0C
#define TMR1L	0x0E
#define TMR1H	0x0F
#define T1CON	0x10
#define TMR2	0x11
#define T2CON	0x12
#define CCPR1L	0x15
#define CCPR1H 	0x16
#define CCP1CON	0x17
#define RCSTA	0x18
#define TXREG	0x19
#define RCREG	0x1A
#define CCPR2L	0x1B
#define CCPR2H 	0x1C
#define CCP2CON	0x1D
#define ADRESH  0x1E
#define ADCON0  0x1F
#define CMCON  0x1F


#define OPTION  0x81
#define TRISA	0x85
#define TRISB	0x86
#define TRISC	0x87
#define TRISD	0x88
#define TRISE	0x89
#define PIE1	0x8C
#define PR2	0x92
#define TXSTA	0x98
#define	SPBRG	0x99
#define EEDATA  0x9A
#define EEADR   0x9B
#define EECON1  0x9C
#define EECON2  0x9D
#define ADRESL  0x9E
#define ADCON1  0x9F


#define PD_OUT	  0x00
#define PD_IN	  0x01


#define PT_CMOS    0x01
#define PT_TTL     0x02	
#define PT_ANALOG  0x04
#define PT_ANAREF  0x05
#define PT_USART   0x06
#define PT_NC  	   0xFF


#ifdef __cplusplus
}
#endif 

