/* ########################################################################

   PICsim - PIC simulator

   ########################################################################

   Copyright (c) : 2008  Luis Claudio Gamba Lopes

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   For e-mail suggestions :  lcgamboa@yahoo.com
   ######################################################################## */

#include<stdio.h>
#include"picsim.h"
#include"p16fxxx.h"
#include"periferic.h"



const int fpw2[8]={1,2,4,8,16,32,64,128};



unsigned short icontrol;

int interrupt(pic16f * pic,int print)
{
//interrupt
  //GIE
  if((pic->ram[INTCON] & 0x80) == 0x80)
  {
    //T0IE
    if(((pic->ram[INTCON] & 0x20) == 0x20)&&((pic->ram[INTCON] & 0x04) != 0x04)&&((icontrol&0x0400) != 0 ))
    {
      icontrol&=~0x0400;
      pic->ram[INTCON]|=0x04;
      return 1;
    }
    
    //INTE
    if(((pic->ram[INTCON] & 0x10) == 0x10)&&((pic->ram[INTCON] & 0x02) != 0x02)&&((icontrol&0x0200) != 0 ))
    {
      icontrol&=~0x0200;
      pic->ram[INTCON]|=0x02;
      return 1;
    }
    
    //RBIE
    if(((pic->ram[INTCON] & 0x08) == 0x08)&&((pic->ram[INTCON] & 0x01) != 0x01)&&((icontrol&0x0100) != 0 ))
    {
      icontrol&=~0x0100;
      pic->ram[INTCON]|=0x01;
      return 1;
    }

    //PEIE	
    if((pic->ram[INTCON] & 0x40) == 0x40)
    {
      
      //EEIE
      if(((pic->ram[PIE1] & 0x80) == 0x80)&&((pic->ram[PIR1] & 0x80) != 0x80)&&((icontrol&0x0080) != 0 ))
      {
        icontrol&=~0x0080;
        pic->ram[PIR1]|=0x80;
        return 1;
      }
      
      //CMIE
      if(((pic->ram[PIE1] & 0x40) == 0x40)&&((pic->ram[PIR1] & 0x40) != 0x40)&&((icontrol&0x0040) != 0 ))
      {
        icontrol&=~0x0040;
        pic->ram[PIR1]|=0x40;
        return 1;
      }
      
      //RCIE
      if(((pic->ram[PIE1] & 0x20) == 0x20)&&((pic->ram[PIR1] & 0x20) != 0x20)&&((icontrol&0x0020) != 0 ))
      {
        icontrol&=~0x0020;
        pic->ram[PIR1]|=0x20;
        return 1;
      }
    
      //TXIE
      if(((pic->ram[PIE1] & 0x10) == 0x10)&&((pic->ram[PIR1] & 0x10) != 0x10)&&((icontrol&0x0010) != 0 ))
      {
        icontrol&=~0x0010;
        pic->ram[PIR1]|=0x10;
        return 1;
      }
      
      //CCP1IE
      if(((pic->ram[PIE1] & 0x04) == 0x04)&&((pic->ram[PIR1] & 0x04) != 0x04)&&((icontrol&0x0004) != 0 ))
      {
        icontrol&=~0x0004;
        pic->ram[PIR1]|=0x04;
        return 1;
      }
      
      //TMR2IE
      if(((pic->ram[PIE1] & 0x02) == 0x02)&&((pic->ram[PIR1] & 0x02) != 0x02)&&((icontrol&0x002) != 0 ))
      {
        icontrol&=~0x0002;
        pic->ram[PIR1]|=0x02;
        return 1;
      }
      
      //TMR1IE
      if(((pic->ram[PIE1] & 0x01) == 0x01)&&((pic->ram[PIR1] & 0x01) != 0x01)&&((icontrol&0x0001) != 0 ))
      {
        icontrol&=~0x0001;
        pic->ram[PIR1]|=0x01;
        return 1;
      }

    }  
  
  }

 return 0;
}

int cp0=0;
int cp1=0;
int cp2=0;
int cp2_=0;
int t2pr=0;

int adcstep=0;

float twdt=0;

int ee_wr=0;

unsigned char porta=128;
unsigned char portb=128;
unsigned char portc=128;
unsigned char portd=128;
unsigned char porte=128;

unsigned char trisa=128;
unsigned char trisb=128;
unsigned char trisc=128;
unsigned char trisd=128;
unsigned char trise=128;


unsigned char adcon1=64;

void 
periferic_step_in(pic16f * pic,int print)
{
//int i,val;
float val;
int chn;
short dval;
//unsigned char port;

//ADC

  if((pic->ADCCOUNT > 0)&&((pic->ram[ADCON0] & 0x01) == 0x01) )  //ADON
  {

  if((pic->ram[ADCON0] & 0x04 ) == 0x04) //GO/DONE
  {
   adcstep++;
   if(adcstep > 10 )
   {
     chn=(pic->ram[ADCON0]&0x38)>>3;


     if(pic->pins[pic->adc[chn]-1].ptype == PT_ANALOG)
     {
       val=pic->pins[pic->adc[chn]-1].avalue;
     }
     else
     {
       val=0;
     }

      dval=((1024*val)/5.0);
   
      if((pic->ram[ADCON1]&0x80) == 0x80)
      { 
        pic->ram[ADRESH]=(dval & 0xFF00)>>8;   	
        pic->ram[ADRESL]=(dval & 0x00FF);   	
      }
      else
      {
        dval= dval <<6;	
        pic->ram[ADRESH]=(dval & 0xFF00)>>8;   	
        pic->ram[ADRESL]=(dval & 0x00FF);   	
      }
    
      pic->ram[ADCON0]&= ~0x04; 
      adcstep=0;
    }
  }
   

 
    
  if((pic->ram[ADCON1]&0x0F) != adcon1)
  {
    switch(pic->ram[ADCON1]&0x0F)
    {
      case 0:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[3]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[4]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[5]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[6]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[7]-1].ptype=PT_ANALOG;
	break;
      case 1:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[3]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[4]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[5]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[6]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[7]-1].ptype=PT_ANALOG;
	break;
      case 2:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[3]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[4]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[5]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 3:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[3]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[4]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[5]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 4:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[3]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[4]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[5]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 5:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[3]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[4]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[5]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 6:
      case 7:
	pic->pins[pic->adc[0]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[1]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[2]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[3]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[4]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[5]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 8:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[3]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[4]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[5]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[6]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[7]-1].ptype=PT_ANALOG;
	break;
      case 9:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[3]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[4]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[5]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 10:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[3]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[4]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[5]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 11:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[3]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[4]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[5]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 12:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[3]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[4]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[5]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 13:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[2]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[3]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[4]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[5]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 14:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[2]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[3]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[4]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[5]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
      case 15:
	pic->pins[pic->adc[0]-1].ptype=PT_ANALOG;
	pic->pins[pic->adc[1]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[2]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[3]-1].ptype=PT_ANAREF;
	pic->pins[pic->adc[4]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[5]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[6]-1].ptype=PT_CMOS;
	pic->pins[pic->adc[7]-1].ptype=PT_CMOS;
	break;
    } 

    adcon1=pic->ram[ADCON1]&0x0F;	
   }
  
  
  }
  else
  {
   adcon1=64;
   adcstep=0;
  };

//TMR0

  if((pic->ram[OPTION] & 0x20) == 0x00 )  //TOCS=FOSC/4
  {
     cp0++;

     if((pic->ram[OPTION] & 0x08) == 0x08) //PSA
     {
        pic->ram[TMR0]++;
        cp0=0;
     }
     else
     { 
        if(cp0 >= 2*(fpw2[pic->ram[OPTION]&0x07]) )
        {
          pic->ram[TMR0]++;
          cp0=0;
        }
     }

  } 

//TMR1

  if((pic->ram[T1CON] & 0x03) == 0x01 )  //TMRICS=FOSC/4 TMREN=1
  {
     cp1++;

     if(cp1 >= fpw2[(pic->ram[T1CON]&0x30)>>4]) 
     {
       pic->ram[TMR1L]++;
       if(pic->ram[TMR1L] == 0)
       {
        pic->ram[TMR1H]++;
       }
       cp1=0;
     }

  } 

//TMR2

  if((pic->ram[T2CON] & 0x04) == 0x04 )  //TMR2EN
  {
     cp2++;
     
     if((pic->ram[T2CON]&0x02) == 0x02)
     {
       t2pr=16;
     }
     else if ((pic->ram[T2CON]&0x01) == 0x01)
     {
       t2pr=4;
     }
     else
     {
       t2pr=1;
     }

     if(cp2 >= t2pr) 
     {
       pic->ram[TMR2]++;
       if(pic->ram[TMR2] == pic->ram[PR2])
       {
         pic->ram[TMR2]=0;
         cp2_++;

         //PWM
          	
	 if((pic->CCPCOUNT >= 1)&&(pic->ccp[0] > 0)&&(pic->ram[CCP1CON]& 0x0C) == 0x0C)
         {
           pic->ram[CCPR1H]=pic->ram[CCPR1L];
           if(pic->pins[pic->ccp[0]-1].dir == PD_OUT)
             pic->ram[pic->pins[(pic->ccp[0]-1)].port]|=0x01<<(pic->pins[(pic->ccp[0]-1)].pord);
         } 
	 
         if((pic->CCPCOUNT >= 2)&&(pic->ccp[1] > 0)&&(pic->ram[CCP2CON]& 0x0C) == 0x0C)
         {
           pic->ram[CCPR2H]=pic->ram[CCPR2L];
           if(pic->pins[pic->ccp[1]-1].dir == PD_OUT)
             pic->ram[pic->pins[(pic->ccp[1]-1)].port]|=0x01<<(pic->pins[(pic->ccp[1]-1)].pord);
         } 
	
       }
       cp2=0;
     }
//PWM - only if TMR2 is on

//only use 8 bits ! not 10 bits  
   if((pic->CCPCOUNT >= 1)&&(pic->ccp[0] > 0)&&(pic->ram[CCP1CON]& 0x0C) == 0x0C)
   {
      if(pic->ram[TMR2] >=  pic->ram[CCPR1H])
      {
        if(pic->pins[pic->ccp[0]-1].dir == PD_OUT)
          pic->ram[pic->pins[(pic->ccp[0]-1)].port]&=~(0x01<<(pic->pins[(pic->ccp[0]-1)].pord));
      }
   }	
   
   if((pic->CCPCOUNT >= 2)&&(pic->ccp[1] > 0)&&(pic->ram[CCP2CON]& 0x0C) == 0x0C)
   {
      if(pic->ram[TMR2] >=  pic->ram[CCPR2H])
      {
        if(pic->pins[pic->ccp[1]-1].dir == PD_OUT)
          pic->ram[pic->pins[(pic->ccp[1]-1)].port]&=~(0x01<<(pic->pins[(pic->ccp[1]-1)].pord));
      }
   }	


  } 



//EEPROM

  if((pic->ram[EECON1] & 0x04) == 0x04 )
  {
    if(pic->ram[EECON2] != 0 )
    {
      if(pic->ram[EECON2] == 0x55 )
      {
        pic->ram[EECON2] = 0; 
        ee_wr=-1;
      }
      else
      {
        if((pic->ram[EECON2] == 0xAA )&&(ee_wr == -1))
        {
          pic->ram[EECON2] = 0; 
          ee_wr=1;
        }
        else
        {
          pic->ram[EECON2] = 0; 
          ee_wr=0;
        }
      }
    }    
  }


  if((pic->ram[EECON1] & 0x03) != 0x00 )
  {
    if((pic->ram[EECON1] & 0x01) == 0x01 ) //RD
    {
      pic->ram[EEDATA]= pic->eeprom[pic->ram[EEADR]];
      pic->ram[EECON1]&=~0x01;  
    }
    else
    {
      if(ee_wr == 1)
      {
        pic->eeprom[pic->ram[EEADR]]=pic->ram[EEDATA];       
        pic->ram[EECON1]&=~0x02; 
        ee_wr=0;
      } 
    }
  } 

//WTD

  if((pic->config[0] & 0x04) == 0x04 )  
  {

    twdt+=4.0/pic->freq;
    
    if((pic->ram[OPTION] & 0x08) == 0x08) //PSA
    {
      if(twdt > (1e-3*fpw2[pic->ram[OPTION] & 0x07]))
      {
        twdt=0;
        pic->wdt++;
        if(pic->wdt == 18)
        {
         //reset
         pic->wdt=0;
   
         pic->ram[((0x0000)<<2)|(STATUS & 0x007F)]&=~0x10;
         pic->ram[((0x0020)<<2)|(STATUS & 0x007F)]&=~0x10;
         pic->ram[((0x0040)<<2)|(STATUS & 0x007F)]&=~0x10;
         pic->ram[((0x0060)<<2)|(STATUS & 0x007F)]&=~0x10;
          
         if( pic->pwd == 1)
         {
           pic->pwd=0;
         } 
         else
         {
           pic_reset(pic,0);
         }
        } 
        //printf("WDT=%02X\n",pic->wdt);
      }
    }
    else
    {
      if(twdt > 1e-3)
      {
        twdt=0;
        pic->wdt++;
        if(pic->wdt == 18)
        {
         //reset
         pic->wdt=0;
         
         pic->ram[((0x0000)<<2)|(STATUS & 0x007F)]&=~0x10;
         pic->ram[((0x0020)<<2)|(STATUS & 0x007F)]&=~0x10;
         pic->ram[((0x0040)<<2)|(STATUS & 0x007F)]&=~0x10;
         pic->ram[((0x0060)<<2)|(STATUS & 0x007F)]&=~0x10;
         
         if( pic->pwd == 1)
         {
           pic->pwd=0;
         } 
         else
         {
           pic_reset(pic,0);
         }
        } 
//        printf("WDT=%02X\n",pic->wdt);
      }
    }
  } 




//pinouts 

/*
   for(i=0;i< pic->PINCOUNT ;i++)
   {
     switch(pic->pins[i].type)
     {
        case P_IC:
	case P_IT:
          if(pic->pins[i].port > 0)
          {
     	      val=0x01<<(pic->pins[i].pord);
              port=pic->pins[i].port;
              if((pic->pins[i].value) == 1)
                pic->ram[port]|=val;
              else	
                pic->ram[port]&=~val;
	   }
	break;
	case P_IA:
	break;
	default:
	break;
     };
   };
*/

   serial(pic,print);
};

void 
periferic_step_out(pic16f * pic,int print)
{
int i,val;

unsigned char port;
unsigned char tris;

//TMR0
  if(((pic->ram[TMR0]) == 0xFF )&& (cp0 ==0))
  {
     icontrol|=0x0400;
  }

//TMR1
  if((pic->ram[TMR1H] == 0xFF)&&((pic->ram[TMR1L]) == 0xFF )&& (cp1 ==0))
  {
     icontrol|=0x0001;
  }

//TMR2
  if(cp2_ >= (((pic->ram[T2CON]&0x78)>>3)+1) )
  {
     cp2_=0; 
     icontrol|=0x0002;
  }


//PINOUTS
  
 if((pic->ram[PORTA] != porta)||
    (pic->ram[PORTB] != portb)||
    (pic->ram[PORTC] != portc)||
    (pic->ram[PORTD] != portd)||
    (pic->ram[PORTE] != porte))
 {
   for(i=0;i<pic->PINCOUNT;i++)
   {
     switch(pic->pins[i].dir)
     {
	case PD_OUT:
//	    case 7:
//               if((pic->ram[RCSTA] & 0x80)==0x80)break; 
//	    case 17:
//              if((pic->ram[RCSTA] & 0x80)==0x80)break;
	      if(pic->pins[i].ptype > 2)break;	 
              val=0x01<<(pic->pins[i].pord);
              port=pic->pins[i].port;
              pic->pins[i].value= ((pic->ram[port] & val) != 0);
	case PD_IN:
	break;
	default:
	break;
     };
    } 
  }

  porta=pic->ram[PORTA];
  portb=pic->ram[PORTB];
  portc=pic->ram[PORTC];
  portd=pic->ram[PORTD];
  porte=pic->ram[PORTE];

 if((pic->ram[TRISA] != trisa)||
    (pic->ram[TRISB] != trisb)||
    (pic->ram[TRISC] != trisc)||
    (pic->ram[TRISD] != trisd)||
    (pic->ram[TRISE] != trise))
 {
   for(i=0;i<pic->PINCOUNT;i++)
   {
     val=0x01<<(pic->pins[i].pord);
     tris=pic->pins[i].port+0x80;
     if((pic->ram[tris] & val)==0)
     {
       pic->pins[i].dir=PD_OUT;
     }
     else
     {
       pic->pins[i].dir=PD_IN;
     }

   };
 };


  trisa=pic->ram[PORTA+0x80];
  trisb=pic->ram[PORTB+0x80];
  trisc=pic->ram[PORTC+0x80];
  trisd=pic->ram[PORTD+0x80];
  trise=pic->ram[PORTE+0x80];

//interrupt
if(pic->s2 == 0)
{
  int temp;

  if(icontrol != 0)
  {
    if (interrupt(pic,print) )
    {
          pic->pwd=0; 

          pic->ram[INTCON]&=~0x80;
          if(print)printf("interrupt!\n");
          for(temp=7;temp>0;temp--)
	    pic->stack[temp]=pic->stack[temp-1];
	  pic->stack[0]=pic->pc;
	  pic->pc=0x0004;
	  pic->s2=1;
    }
  }  
}

};
   
