/* ########################################################################

   PICsim - PIC simulator

   ########################################################################

   Copyright (c) : 2008  Luis Claudio Gamba Lopes

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   For e-mail suggestions :  lcgamboa@yahoo.com
   ######################################################################## */


#include<stdio.h>
#include<stdlib.h>
#include<string.h>
#include<unistd.h>
#include"picsim.h"
#include"p16fxxx.h"

#ifdef _WIN_
#include<windows.h>
#define usleep(x) Sleep(x)
#endif


int 
main(int argc,char** argv)
{
  pic16f pic1; 
  
  char c=0;

  if(argc == 2)
  {
    pic_init(&pic1,P16F628A,argv[1],1,4e6);
  
    while(c != 'q')
    {
      pic_step(&pic1,1);
  
      printf("pc=%#06X w=%#04X 0x00=%#04X 0x04=%#04X 0x05=%#04X 0x06=%#04X status=%#04X intcon=%#04X\n",pic1.pc,pic1.w,pic1.ram[0x00],pic1.ram[0x04],pic1.ram[0x05],pic1.ram[0x06],pic1.ram[STATUS],pic1.ram[INTCON]);
     /* 
      for(i=0;i<18;i++)
        printf("%02i %i %i\n",i,pic1.pins[i].type, pic_get_pin(&pic1,i+1));
      */
      c=getchar();
      
      usleep(1);
    };

     pic_end(&pic1);
   }
   else
   {
     printf("use: %s file.hex\n",argv[0]);
#ifdef _WIN_
    system("PAUSE");
#endif        
   }
    return 1;
}


