/* ########################################################################

   PICsim - PIC simulator

   ########################################################################

   Copyright (c) : 2008  Luis Claudio Gamba Lopes

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

   For e-mail suggestions :  lcgamboa@yahoo.com
   ######################################################################## */


#ifdef __cplusplus
extern "C" {
#endif 


extern char SERIALDEVICE[100];


#define P16F628     0x07c0
#define P16F877     0x09a0
#define P16F628A    0x1060	
#define P16F877A    0x0e20



typedef struct
{
unsigned char ptype;     //type
unsigned char dir;       //dir
unsigned char value;     //value
char pord;               //pin port number
unsigned char port;      //port
float avalue;            //analog value
}picpin;


typedef struct 
{
  unsigned int  RAMSIZE;
  unsigned int  ROMSIZE;
  unsigned int  EEPROMSIZE;
  unsigned int  IDSIZE;
  unsigned int  CONFIGSIZE;	
  unsigned char  PINCOUNT;
  unsigned char CCPCOUNT;
  unsigned char ADCCOUNT;
  unsigned int  processor;
  unsigned char  *ram;
  unsigned short *prog;
  unsigned short *id;
  unsigned char  *eeprom;
  unsigned short *config;
  unsigned short pc;
  unsigned short lram;  //loaded register 
  unsigned short rram;  //readed register 
  unsigned short stack[8];
  unsigned char  w;
  unsigned char  wdt;
  unsigned char  s2;
  float   	 freq;
  unsigned char  pwd;
  picpin *pins;
  unsigned char *ccp;
  unsigned char *adc;
  unsigned char *usart;
} pic16f;



int pic_init(pic16f * pic,int processor, const char * fname, int lrom,float freq);
int pic_reset(pic16f * pic,int flags);
void pic_step(pic16f * pic,int print);
void pic_end(pic16f * pic);

unsigned char pic_get_pin(pic16f * pic, unsigned char pin);
int pic_set_pin(pic16f * pic,unsigned char pin,unsigned char value);
unsigned char pic_get_pin_type(pic16f * pic, unsigned char pin);
unsigned char pic_get_pin_dir(pic16f * pic, unsigned char pin);


#ifdef __cplusplus
}
#endif 

