//---------------------------------------------------------------------------
//
// Name:        serialFrm.cpp
// Author:      gamboa
// Created:     8/29/sexta-feira 09:42:49
// Description: serialFrm class implementation
//
//---------------------------------------------------------------------------

#include "serialFrm.h"

//Do not add custom headers between
//Header Include Start and Header Include End
//wxDev-C++ designer will remove them
////Header Include Start
////Header Include End

//----------------------------------------------------------------------------
// serialFrm
//----------------------------------------------------------------------------
//Add Custom Events only in the appropriate block.
//Code added in other places will be removed by wxDev-C++
////Event Table Start
BEGIN_EVENT_TABLE(serialFrm,wxFrame)
	////Manual Code Start
	////Manual Code End
	
	EVT_CLOSE(serialFrm::OnClose)
	EVT_TIMER(ID_WXTIMER1,serialFrm::WxTimer1Timer)
END_EVENT_TABLE()
////Event Table End


#include <stdio.h>
#include <string.h>

#ifdef _WIN_
#include <conio.h>
#include <time.h>
#include <windows.h>

#define BAUDRATE 9600
#define MODEMDEVICE "COM2"

HANDLE hCom;
#else
#include <termios.h>
#define BAUDRATE B9600
#define MODEMDEVICE "/dev/tnt3"

int fd;
#endif

serialFrm::serialFrm(wxWindow *parent, wxWindowID id, const wxString &title, const wxPoint &position, const wxSize& size, long style)
: wxFrame(parent, id, title, position, size, style)
{
	CreateGUIControls();


	// insert your code here

	/*serialopen*/
	// variables used with the com port
#ifdef _WIN_
BOOL bPortReady;
DCB dcb;
COMMTIMEOUTS CommTimeouts;


//configurao

hCom = CreateFile(MODEMDEVICE, GENERIC_READ | GENERIC_WRITE,
0, // exclusive access
NULL, // no security
OPEN_EXISTING,
0, // no overlapped I/O
NULL); // null template

bPortReady = SetupComm(hCom, 2, 128); // set buffer sizes

bPortReady = GetCommState(hCom, &dcb);
dcb.BaudRate = BAUDRATE;
dcb.ByteSize = 8;
dcb.Parity = NOPARITY;
dcb.StopBits = ONESTOPBIT;
dcb.fAbortOnError = TRUE;

// set XON/XOFF
dcb.fOutX = FALSE; // XON/XOFF off for transmit
dcb.fInX = FALSE; // XON/XOFF off for receive
// set RTSCTS
dcb.fOutxCtsFlow = FALSE; // turn off CTS flow control
dcb.fRtsControl = RTS_CONTROL_HANDSHAKE; //
// set DSRDTR
dcb.fOutxDsrFlow = FALSE; // turn off DSR flow control
//dcb.fDtrControl = DTR_CONTROL_ENABLE; //
dcb.fDtrControl = DTR_CONTROL_DISABLE; //
// dcb.fDtrControl = DTR_CONTROL_HANDSHAKE; //

bPortReady = SetCommState(hCom, &dcb);

// Communication timeouts are optional

bPortReady = GetCommTimeouts (hCom, &CommTimeouts);

CommTimeouts.ReadIntervalTimeout = MAXDWORD;
CommTimeouts.ReadTotalTimeoutConstant = 0;
CommTimeouts.ReadTotalTimeoutMultiplier = 0;
CommTimeouts.WriteTotalTimeoutConstant = 0;
CommTimeouts.WriteTotalTimeoutMultiplier = 0;

bPortReady = SetCommTimeouts (hCom, &CommTimeouts);
#else
  struct termios newtio;
  
  fd = open(MODEMDEVICE, O_RDWR | O_NOCTTY | O_NONBLOCK); 
  if (fd < 0) 
  {
    perror(MODEMDEVICE); 
  }
   
        
//        tcgetattr(fd,&oldtio); /* save current port settings */
        
        bzero(&newtio, sizeof(newtio));
        newtio.c_cflag = BAUDRATE |CS8 | CLOCAL | CREAD;
        newtio.c_iflag = IGNPAR|IGNBRK;
        newtio.c_oflag = 0;
        
        /* set input mode (non-canonical, no echo,...) */
        newtio.c_lflag = 0;
         
        newtio.c_cc[VTIME]    = 0;   /* inter-character timer unused */
        newtio.c_cc[VMIN]     = 5;   /* blocking read until 5 chars received */
        
        tcflush(fd, TCIFLUSH);
        tcsetattr(fd,TCSANOW,&newtio);

#endif
}

serialFrm::~serialFrm()
{
}

void serialFrm::CreateGUIControls()
{
	//Do not add custom code between
	//GUI Items Creation Start and GUI Items Creation End
	//wxDev-C++ designer will remove them.
	//Add the custom code before or after the blocks
	////GUI Items Creation Start

	WxPanel1 = new wxPanel(this, ID_WXPANEL1, wxPoint(0,0), wxSize(320,254));
	WxPanel1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox1 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX1, wxT("Saida 1"), wxPoint(16,24), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox1"));
	WxCheckBox1->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox2 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX2, wxT("Saida 2"), wxPoint(16,47), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox2"));
	WxCheckBox2->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox3 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX3, wxT("Saida 3"), wxPoint(16,72), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox3"));
	WxCheckBox3->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox4 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX4, wxT("Saida 4"), wxPoint(16,96), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox4"));
	WxCheckBox4->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox5 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX5, wxT("Saida 5"), wxPoint(16,120), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox5"));
	WxCheckBox5->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox6 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX6, wxT("Saida 6"), wxPoint(16,144), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox6"));
	WxCheckBox6->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox7 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX7, wxT("Saida 7"), wxPoint(16,168), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox7"));
	WxCheckBox7->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox8 = new wxCheckBox(WxPanel1, ID_WXCHECKBOX8, wxT("Saida 8"), wxPoint(16,192), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox8"));
	WxCheckBox8->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox1_ = new wxCheckBox(WxPanel1, ID_WXCHECKBOX1_, wxT("Entrada 1"), wxPoint(192,24), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox1_"));
	WxCheckBox1_->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox2_ = new wxCheckBox(WxPanel1, ID_WXCHECKBOX2_, wxT("Entrada 2"), wxPoint(192,48), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox2_"));
	WxCheckBox2_->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox3_ = new wxCheckBox(WxPanel1, ID_WXCHECKBOX3_, wxT("Entrada 3"), wxPoint(192,72), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox3_"));
	WxCheckBox3_->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox4_ = new wxCheckBox(WxPanel1, ID_WXCHECKBOX4_, wxT("Entrada 4"), wxPoint(192,96), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox4_"));
	WxCheckBox4_->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox5_ = new wxCheckBox(WxPanel1, ID_WXCHECKBOX5_, wxT("Entrada 5"), wxPoint(192,120), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox5_"));
	WxCheckBox5_->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox6_ = new wxCheckBox(WxPanel1, ID_WXCHECKBOX6_, wxT("Entrada 6"), wxPoint(192,144), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox6_"));
	WxCheckBox6_->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox7_ = new wxCheckBox(WxPanel1, ID_WXCHECKBOX7_, wxT("Entrada 7"), wxPoint(192,168), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox7_"));
	WxCheckBox7_->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxCheckBox8_ = new wxCheckBox(WxPanel1, ID_WXCHECKBOX8_, wxT("Entrada 8"), wxPoint(192,192), wxSize(97,17), 0, wxDefaultValidator, wxT("WxCheckBox8_"));
	WxCheckBox8_->SetFont(wxFont(8, wxSWISS, wxNORMAL,wxNORMAL, false, wxT("Tahoma")));

	WxTimer1 = new wxTimer();
	WxTimer1->SetOwner(this, ID_WXTIMER1);
	WxTimer1->Start(100);

	SetTitle(wxT("serial"));
	SetIcon(wxNullIcon);
	SetSize(8,8,328,281);
	Center();
	
	////GUI Items Creation End
}

void serialFrm::OnClose(wxCloseEvent& event)
{
	Destroy();
}


/*
 * WxTimer1Timer
 */
void serialFrm::WxTimer1Timer(wxTimerEvent& event)
{
    // insert your code here

    unsigned long nbytes=0;
    char valor=0;
    
    if (WxCheckBox1->GetValue() == true) valor|=0x01;    
	if (WxCheckBox2->GetValue() == true) valor|=0x02;   
	if (WxCheckBox3->GetValue() == true) valor|=0x04;   
	if (WxCheckBox4->GetValue() == true) valor|=0x08;   
	if (WxCheckBox5->GetValue() == true) valor|=0x10;   
	if (WxCheckBox6->GetValue() == true) valor|=0x20;   
	if (WxCheckBox7->GetValue() == true) valor|=0x40;   
	if (WxCheckBox8->GetValue() == true) valor|=0x80;   
	
 #ifdef _WIN_   
    WriteFile(hCom, &valor, 1, &nbytes,NULL);
    
    ReadFile(hCom, &valor, 1,&nbytes, NULL);
 #else
    write (fd,&valor,1);   

    nbytes= read (fd,&valor,1);   
 #endif

    if(nbytes == 1)
    {
    if((valor&0x01) != 0) 
      WxCheckBox1_->SetValue(true); 
    else
      WxCheckBox1_->SetValue(false);
	if((valor&0x02) != 0)
      WxCheckBox2_->SetValue(true);
    else
      WxCheckBox2_->SetValue(false);
	if((valor&0x04) != 0)
      WxCheckBox3_->SetValue(true);
    else
      WxCheckBox3_->SetValue(false);
	if((valor&0x08) != 0)
      WxCheckBox4_->SetValue(true);
    else
      WxCheckBox4_->SetValue(false);
	if((valor&0x10) != 0)
      WxCheckBox5_->SetValue(true);
    else
      WxCheckBox5_->SetValue(false);
	if((valor&0x20) != 0)
      WxCheckBox6_->SetValue(true);
    else
      WxCheckBox6_->SetValue(false);
	if((valor&0x40) != 0)
      WxCheckBox7_->SetValue(true);
    else
      WxCheckBox7_->SetValue(false);
	if((valor&0x80) != 0)
      WxCheckBox8_->SetValue(true);
    else
      WxCheckBox8_->SetValue(false);      
    }       
                                
}

